% It writes which mouse button and where you have pressed on the graph.
%
% This is ginput.m implementation for gnuplot and X11.
% It requires gnuplot 4.0 (or later).
%
% Author: Petr Mikulik, 2004
% License: public domain
% History of changes: 
%	May 2, 2004: Changed 'pause mouse\n' to 'pause mouse\n\n' to fix an
%		     eaten character (needed if gnuplot is changed so that
%		     the automatic replot is after each 'pause mouse' is
%		     disabled).
%		     
%	April 2004: release for gnuplot 4.0

function [x, y, button] = ginput ( n )

if nargin ~= 1
    n = 1;
end
if nargout == 3
    button = 0;
end

if nargin > 1
    x = zeros(n, 1);
    y = zeros(n, 1);
    mb = zeros(n, 1);
    button = zeros(n, 1);
end

% gpinName = sprintf('./OctGnuplot%i', getpid);
gpinName = tmpnam();
[err, msg] = mkfifo(gpinName, 6*8*8); % 6*8*8) % 0600

for k=1:n
    graw(['set print "', gpinName, '";\n']);
    gpin = fopen(gpinName,'r');

    %graw('pause mouse "enjoy a mouse click"\n');
    graw('pause mouse\n\n');

    graw('print MOUSE_X, MOUSE_Y, MOUSE_BUTTON\n');
    graw('set print\n'); % close output file, otherwise all blocks (why?!)

    % Now read from fifo
    %a = fgets(gpin,999) % for testing -- this shows the whole line
    [x(k), y(k), mb(k), count] = fscanf(gpin, '%f %f %d', 'C');
    button(k) = mb(k);
    if 0
	printf('ginput.m: You pressed mouse button %d at x=%f y=%f\n', mb, x, y);
    end

    fclose(gpin);
end

unlink(gpinName);

% endfunction

% eof ginput.m
